--TaroNuke's Mod system. Taken from Puuro's 'Hopes And Dreams' file.
--Since this is intended to work on most SM5 versions, I'll use this. -Kid
LoadActor("mods-taro.lua") --Load another lua file.
--For the easing table. -Kid
local poptions = {GAMESTATE:GetPlayerState(0):GetPlayerOptions('ModsLevel_Song'),GAMESTATE:GetPlayerState(1):GetPlayerOptions('ModsLevel_Song')}
--Scaling this is like scaling havox, but with more breezy. -Kid
local i_height_ratio = SCREEN_HEIGHT/480
local i_width_ratio = SCREEN_WIDTH/640
local i_sdwidth_ratio = (480*(SCREEN_WIDTH/SCREEN_HEIGHT))/640
return Def.ActorFrame{
  Name= "actor_ai",
  InitCommand= function(self)

	songName = GAMESTATE:GetCurrentSong():GetSongDir();
	
	sw = SCREEN_WIDTH
	sh = SCREEN_HEIGHT --shortcuts
	
	function Plr(pn)
		return _G['P'..pn]
	end
	
	function mod_do(str,pn)
		if pn then
			--GAMESTATE:ApplyGameCommand('mod,'..str,pn)
			taronuke_mods(str,pn)
		else
			--GAMESTATE:ApplyGameCommand('mod,'..str)
			taronuke_mods(str,1)
			taronuke_mods(str,2)
		end
	end
	
end,
  Def.Quad{
    Name= "actor_bi",
    InitCommand= cmd(visible,false),
    OnCommand= cmd(sleep,1000),
  },
  LoadActor('modhelpers.lua') .. {
    Name= "actor_ci",
    File= "modhelpers.lua",
  },
  LoadActor('easing.lua') .. {
    Name= "actor_di",
    File= "easing.lua",
  },
  Def.Quad{
    Name= "actor_ei",
    InitCommand= function(self)
		
			checked = false;
		
			---------------------------------------------------------
			---------DOCUMENTATION-----------------------------------
			---------------------------------------------------------
			
			--function perframe( beat, endBeat )
				--return true if the current beat is between 'beat' and 'endBeat'
			
			--function mod_shader(beat,key,which)
				--turn on shader key at specified beat (up to 10 keys available, defined by 'which' = 0-9
				
			--function mod_insert(beat,len,mod,len_or_end,pn)
				--insert mod into beat mods table
			--function mod_insert2(time,len,mod,len_or_end,pn)
				--insert mod into time mods table
				
			--function mod_message(beat,msg,persistent)
				--insert something into the actions table.
				--msg can also be a function. If string, a message gets broadcast at that beat
				--if 'persistent' is true, message will run even if editor starts at a beat past it
				
			--function mod_blacklist(t,n)
				--check if number n occurs in table t
				--useful for doing 'every beat EXCEPT the contents of t'
				
			--function simple_m0d(beat,strength,mult,mod)
			--function simple_m0d2(beat,strength,mult,mod,pn)
			--function simple_m0d3(beat,strength,duration,bpm,mod,pn)
				--activate mods at specific beat but also deactivate them
				
			--function mod_wiggle(beat,num,div,amt,speed,mod,pn,first)
				--alternates a mod back and forth before resetting to 0
				
			--function mod_springt(time,strength,dur,mod,pn)
				--time-based per-frame alternating mod that decreases based on how much time is left.
					--think doorstopper
			
			--function mod_springt2(time,strength,dur,mod,pn)
				--time-based per-frame alternating mod
			
			--function mod_onebeat(beat,strength,pn)
				--turns on beat for the beat specified, at the desired strength	
			
			--function switcheroo_add(beat,which,speed,len,pn)
				--adds a column swap at the desired beat
			--[[	switcheroos = {normal = {0,0}, ldur = {0,0}, reset = {0,0},
					flip = {100,0}, rudl = {100,0}, invert = {0,100}, dlru = {0,100},
					ludr = {25,-75}, rdul = {75,75}, drlu = {25,125}, ulrd = {75,-125}, urld = {100,-100}}
			]]
			
			--use a variable called 'switcheroo_width' to change how much space is between each column
			--e.g. switcheroo_width = 2 for ayakashi
			
			--function mod_sugarkiller(beat,duration,speed,minstealth,maxstealth,pn)
				--portable version of the effect from sugarkill X
				
			--function doSpline(spd, axis, path, col)
				--draws spline 'path' in specified axis, for specific col. Offsets are *10000, but positions use *spd
				
			--function doSplineAll(spd, axis, path)
				--same as above, but for all columns
				--(faster performance than using doSpline 4 times due to more efficient concat)
			
			--function mindf_rotateAndCounter(xDegrees, yDegrees, zDegrees, player)
				--counteract euler rotations after rotating player in multiple axes, using a TON of math.
			
			
			---------------------------------------------------------
			--------END DOCUMENTATION--------------------------------
			---------------------------------------------------------
			
			local m = mod_insert
			local m2 = mod_message
			
			
			
			
			
			
			
			
			
			
			init_modsp1 = '';
			init_modsp2 = '';
			
			mod_plr = {nil, nil};--A true test of everything. No errors allowed! -Kid
			
			mod_firstSeenBeat = GAMESTATE:GetSongBeat(); --necessary to prevent long freezes
			
			
			
			
			
			
			
			
			
			
			
---------------------------------------------------------------------------------------
----------------------Begin tables 'n stuff--------------------------------------------
---------------------------------------------------------------------------------------

			--beat based mods
			--{beat_start, beat_end, mods, len_or_end, player_number}
			mods = {
				{0,9999,'*2 2x, *10000 -9999 cover','end'},
				{115,119,'*10000 1000% Sudden, *10000 160% SuddenOffset','end'},--Because 5.2 -Kid
				{119,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},
				{186.4,188,'*10000 1000% Sudden, *10000 160% SuddenOffset','end'},
				{188,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},
			}
			
			--switcheroos = {{0,0},{100,0},{0,100},{25,-75},{75,75},{25,125},{75,-125},{100,-100}}
			
			
			
			
			
			
			
			--time based mods
			mod_time = 0;
			--{time_start, time_end, mods, len_or_end, player_number}
			mods2 = {
				--{0,200.345,'3x','end',1},
			}
			
			
			
			
			
			--beat-based ease mods
			--{time_start, time_end, mod_start, mod_end, mod, len_or_end, ease_type, player_number, sustaintime, optional_param1, optional_param2}
			--valid ease types are:
				--linear
				--inQuad    outQuad    inOutQuad    outInQuad
				--inCubic   outCubic   inOutCubic   outInCubic
				--inQuart   outQuart   inOutQuart   outInQuart
				--inQuint   outQuint   inOutQuint   outInQuint
				--inSine    outSine    inOutSine    outInSine
				--inExpo    outExpo    inOutExpo    outInExpo
				--inCirc    outCirc    inOutCirc    outInCirc
				--inElastic outElastic inOutElastic outInElastic    --can take 2 optional parameters - amplitude & period
				--inBack    outBack    inOutBack    outInBack       --can take 1 optional parameter  - spring amount
				--inBounce  outBounce  inOutBounce  outInBounce
				
			mods_ease = {
			}
			
			i_startime = 0;
			
			--this is both a message broadcaster and a function runner
			--if you put {beat,'String'}, then 'String' is broadcast as a message on that beat
			--if you put {beat,function() somecode end}, then function() is run at that beat
			--see example on beat 32
			
			curaction = 1;
			--{beat,thing,persists}
			mod_actions = {
			
				{8,function()
					i_bg:diffusealpha(1);
				end,true},
			
				{6,'Fade'},
				{8,'Open'},
				
				{24,'OpenQ',true},
				
				{64,'Fade2'},
				{70,'I'},
				
				{72.75,'Breezy'},
				{76,'Unfade'},
				
				{76,function()
					fms_bg:visible(false)
					_G['tama_bg'..math.random(1, 8)]:visible(true)
				end,true},
				
				{227,'I'},
				
			}
			
			
			
			
			
			
			
			
---------------------------------------------------------------------------------------
----------------------Sort the actions table-------------------------------------------
---------------------------------------------------------------------------------------
			
			function modtable_compare(a,b)
				return a[1] < b[1]
			end
			
			self:queuecommand('Update');
			
		end,
    OnCommand= cmd(visible,false),
    UpdateCommand= function(self)

			if GAMESTATE:GetSongBeat()>=0 and not checked then
			
				--Added more things to grab/hide. -Kid
				local ThingsToGrab = {'LifeP1','LifeP2','ScoreP1','ScoreP2','BPMDisplay','LifeFrame','ScoreFrame',
				'Lyrics','SongBackground','SongForeground','Overlay','Underlay','StageDisplay'
				,'SongTitle','SongMeterDisplayP1','SongMeterDisplayP2','StepsDisplayP1',
				'StepsDisplayP2','LifeMeterBarP1','LifeMeterBarP2'}
				local ThingsToHide = {'LifeP1','LifeP2','ScoreP1','ScoreP2','BPMDisplay','LifeFrame','ScoreFrame',
				'Overlay','Underlay','StageDisplay','SongTitle','SongMeterDisplayP1',
				'SongMeterDisplayP2','StepsDisplayP1','StepsDisplayP2','LifeMeterBarP1',
				'LifeMeterBarP2'}
				
				for i,v in ipairs(ThingsToGrab) do
					_G[v] = SCREENMAN:GetTopScreen():GetChild(v) or nil
				end
				
				for i,v in ipairs(ThingsToHide) do
					if _G[v] then _G[v]:visible(false) end
				end
				
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
				
				--name players, judgment and combo
				for pn=1,2 do
					_G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil;
					if _G['P'..pn] then
						_G['jud'..pn] = _G['P'..pn]:GetChild('Judgment');
						_G['com'..pn] = _G['P'..pn]:GetChild('Combo');
						_G['P_RAP'..pn] = _G['P'..pn]:AddWrapperState()--For one part that may not even happen. -Kid
					end
				end
				
				screen = SCREENMAN:GetTopScreen();
				if table.getn(mod_actions) > 1 then
					table.sort(mod_actions, modtable_compare)
				end
				checked = true; --let this only run once
				
			end

			local beat = GAMESTATE:GetSongBeat()
			
			
---------------------------------------------------------------------------------------
----------------------Begin table handlers---------------------------------------------
---------------------------------------------------------------------------------------
			
			disable = false;
			if disable ~= true and checked then
				
				-----------------------
				-- Player mod resets --
				-----------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i=1,2 do
						mod_do('clearall',i)
					end
				end
				
				------------------------------------------------------------------------------
				-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
				------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if beat >=v[1] then
								if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
									if table.getn(v) == 5 then
										mod_do(v[3],v[5]);
									else
										mod_do(v[3]);
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = '';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')');
						end
					end
				end
				
				-----------------------------------------------------------------------------------------------------
				-- WinDEU's time-based len/end version of the #swag custom mod reader #teamproofofconcept (c) 2015 --
				-----------------------------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods2) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if mod_time >=v[1] then
								if (v[4] == 'len' and mod_time <=v[1]+v[2]) or (v[4] == 'end' and mod_time <=v[2]) then
									if table.getn(v) == 5 then
										mod_do(v[3],v[5]);
									else
										mod_do(v[3]);
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = 'error';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in time-based table (line '..i..')');
						end
					end
				end
				
				---------------------------------------------------
				-- ease mod reader v2                            --
				-- friendship ended with if wall                 --
				-- now functions as parameters is my best friend --
				---------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods_ease) do
						if v and table.getn(v) > 6 and v[1] and v[2] and v[3] and v[4] and v[5] and v[6] and v[7] then
							if beat >=v[1] then
								if (v[6] == 'len' and beat <=v[1]+v[2]) or (v[6] == 'end' and beat <=v[2]) then
									
									local duration = v[2];
									if v[6] == 'end' then duration = v[2] - v[1] end
									local curtime = beat - v[1]
									local diff = v[4] - v[3]
									local startstrength = v[3]
									local curve = v[7]
									local mod = v[5]
									
									local strength = curve(curtime, startstrength, diff, duration, v[10], v[11]) --extra parameters for back and elastic eases :eyes:
									
									if v[5] == 'xmod' then
										if table.getn(v) >= 8 then
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..strength..'x',v[8]);
											poptions[v[8]]:XMod(strength,10000)
										else
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..strength..'x');
											poptions[1]:XMod(strength,10000)
											poptions[2]:XMod(strength,10000)
										end
									else
										if table.getn(v) >= 8 then
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..strength..' '..mod,v[8]);
											poptions[v[8]][mod](poptions[v[8]],strength/100,10000)
										else
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..strength..' '..mod);
											poptions[1][mod](poptions[1],strength/100,10000)
											poptions[2][mod](poptions[2],strength/100,10000)
										end
									end
								elseif (v[9] and ((v[6] == 'len' and beat <=v[1]+v[2]+v[9]) or (v[6] == 'end' and beat <=v[9]))) then
									if v[5] == 'xmod' then
										if v[8] then
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..v[4]..'x', v[8]);
											poptions[v[8]]:XMod(v[4],10000)
										else
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..v[4]..'x');
											poptions[1]:XMod(v[4],10000)
											poptions[2]:XMod(v[4],10000)
										end
									else
										if v[8] then
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..v[4]..' '..v[5], v[8]);
											poptions[v[8]][v[5]](poptions[v[8]],v[4]/100,10000)
										else
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..v[4]..' '..v[5]);
											poptions[1][v[5]](poptions[1],v[4]/100,10000)
											poptions[2][v[5]](poptions[2],v[4]/100,10000)
										end
									end
								end
							end
						else
							SCREENMAN:SystemMessage('Bad mod in beat-based ease table (line '..i..')');
						end
					end
				end
				
				--------------------
				-- Perframe stuff --
				--------------------
				
				
				
				---------------------------------------
				-- ACTION RPGS AINT GOT SHIT ON THIS --
				---------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
						if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
							if type(mod_actions[curaction][2]) == 'function' then
								mod_actions[curaction][2]()
							elseif type(mod_actions[curaction][2]) == 'string' then
								MESSAGEMAN:Broadcast(mod_actions[curaction][2]);
							end
						end
						curaction = curaction+1;
					end
				end
				
			end
			
			self:sleep(0.02);
			self:queuecommand('Update');

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
  },
  Def.Quad{
    Name= "actor_fi",
    OnCommand= cmd(stretchto,0,0,SCREEN_WIDTH,SCREEN_HEIGHT),
    OpenMessageCommand= cmd(sleep,6*60/225;linear,10*60/225;diffusealpha,0),
    OpenQMessageCommand= cmd(visible,false),
  },
  Def.Quad{
    Name= "actor_gi",
    OnCommand= cmd(stretchto,0,0,SCREEN_WIDTH,SCREEN_HEIGHT/2;diffuse,color('0,0,0,1')),
    OpenMessageCommand= cmd(linear,16*60/225;addy,-SCREEN_HEIGHT*0.5),
    OpenQMessageCommand= cmd(visible,false),
  },
  Def.Quad{
    Name= "actor_hi",
    OnCommand= cmd(stretchto,0,SCREEN_HEIGHT/2,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,color('0,0,0,1')),
    OpenMessageCommand= cmd(linear,16*60/225;addy,SCREEN_HEIGHT*0.5),
    OpenQMessageCommand= cmd(visible,false),
  },
  Def.Sprite{
    Name= "actor_ii",
    FadeMessageCommand= cmd(linear,120/225;diffuse,color('.3,.3,.3,1')),
    OnCommand= cmd(stretchto,0,0,SCREEN_WIDTH,SCREEN_HEIGHT;cropbottom,0.5;diffuse,color('0.5,0.5,0.5,1')),
    OpenMessageCommand= cmd(linear,16*60/225;addy,-SCREEN_HEIGHT*0.5-50;diffuse,color('0,0,0,1')),
    OpenQMessageCommand= cmd(visible,false),
    Texture= "itg.png",
  },
  Def.Sprite{
    Name= "actor_ji",
    FadeMessageCommand= cmd(linear,120/225;diffuse,color('.3,.3,.3,1')),
    OnCommand= cmd(stretchto,0,0,SCREEN_WIDTH,SCREEN_HEIGHT;croptop,0.5;diffuse,color('0.5,0.5,0.5,1')),
    OpenMessageCommand= cmd(linear,16*60/225;addy,SCREEN_HEIGHT*0.5+50;diffuse,color('0,0,0,1')),
    OpenQMessageCommand= cmd(visible,false),
    Texture= "itg.png",
  },
  Def.Quad{
    Name= "actor_ki",
    OnCommand= cmd(stretchto,0,0,SCREEN_WIDTH,SCREEN_HEIGHT/2;diffuse,color('1,1,1,0');fadetop,0.4;croptop,0.6),
    OpenMessageCommand= cmd(diffusealpha,.4;linear,16*60/225;addy,-SCREEN_HEIGHT*0.5;diffusealpha,0),
    OpenQMessageCommand= cmd(visible,false),
  },
  Def.Quad{
    Name= "actor_li",
    OnCommand= cmd(stretchto,0,SCREEN_HEIGHT/2,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,color('1,1,1,0');fadebottom,0.4;cropbottom,0.6),
    OpenMessageCommand= cmd(diffusealpha,.4;linear,16*60/225;addy,SCREEN_HEIGHT*0.5;diffusealpha,0),
    OpenQMessageCommand= cmd(visible,false),
  },
  Def.Sprite{
    Name= "actor_mi",--Scale customtexturerect and zoom, added zoomx. -Kid
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;customtexturerect,0,0,4*i_sdwidth_ratio,4;blend,"BlendMode_Add";zoom,4*i_height_ratio;zoomx,4*i_width_ratio;diffusealpha,0),
    OpenMessageCommand= cmd(linear,0.1;diffusealpha,0.1;linear,16*60/225;diffusealpha,0),
    Texture= "tex2.png",
  },
  Def.Sprite{
    Name= "actor_ni",
    OnCommand= cmd(stretchto,0,0,SCREEN_WIDTH,SCREEN_HEIGHT;diffusealpha,0),
    OpenMessageCommand= cmd(linear,0.1;diffusealpha,0.5),
    Texture= "vig.png",
  },
  Def.Quad{
    Name= "actor_oi",
    Fade2MessageCommand= cmd(accelerate,6*60/225;diffusealpha,1),
    IMessageCommand= cmd(diffuse,color('0,0,0,1')),
    OnCommand= cmd(stretchto,0,0,SCREEN_WIDTH,SCREEN_HEIGHT;diffusealpha,0),
    UnfadeMessageCommand= cmd(linear,1;diffusealpha,0),
  },
  Def.Sprite{
    Name= "actor_pi",--Scale zooms. -Kid
    IMessageCommand= cmd(zoom,10*i_height_ratio;decelerate,0.3;zoomx,1.5*i_height_ratio;zoomy,0),
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoom,0),
    Texture= "transition.png",
  },
  Def.Sprite{
    Name= "actor_qi",--Scale position and zoom. -Kid
    BreezyMessageCommand= cmd(diffusealpha,1;linear,1;diffusealpha,0),
    OnCommand= cmd(x,SCREEN_CENTER_X+60*i_width_ratio;y,SCREEN_BOTTOM;vertalign,bottom;zoom,.9*i_height_ratio;diffusealpha,0),
    Texture= "tamaneko.png",
  },
  LoadActor('exchwation') .. {
    Name= "actor_ri",
    File= "exchwation",
  },
  LoadActor('helseeonicks') .. {
    Name= "actor_si",
    File= "helseeonicks",
  },
  LoadActor('doiqi') .. {
    Name= "actor_ti",
    File= "doiqi",
  },
  LoadActor('./New folder') .. {
    Name= "actor_ui",
    File= "./New folder",
  },
  Def.BitmapText{
    Name= "actor_vi",
    Font= "Common Normal",
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,"music";playcommand,"SetTime";visible,false),
    SetTimeCommand= function(self) self:settext(self:GetSecsIntoEffect()); mod_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
    Text= "test",
  },
}
