--TaroNuke's Mod system. Taken from Puuro's 'Hopes And Dreams' file.
--Since this is intended to work on most SM5 versions, I'll use this. -Kid
LoadActor("mods-taro.lua") --Load another lua file.
--For the easing table. -Kid
local poptions = {GAMESTATE:GetPlayerState(0):GetPlayerOptions('ModsLevel_Song'),GAMESTATE:GetPlayerState(1):GetPlayerOptions('ModsLevel_Song')}
--Scaling vars. -Kid
local liloss_sdwidth_ratio = (480*(SCREEN_WIDTH/SCREEN_HEIGHT))/640
local liloss_width_ratio = SCREEN_WIDTH/640
local liloss_height_ratio = SCREEN_HEIGHT/480
return Def.ActorFrame{
  Name= "actor_s",
  InitCommand= function(self)
	
	songName = GAMESTATE:GetCurrentSong():GetSongDir();
	
	m_bl = 60/114 --use this to define length of a beat for use in the rest of the song
	sw = SCREEN_WIDTH
	sh = SCREEN_HEIGHT --shortcuts
	
	function Plr(pn)
		return _G['P'..pn]
	end
end,
  Def.Quad{
    Name= "actor_t",
    InitCommand= cmd(visible,false),
    OnCommand= cmd(sleep,1000),
  },
  LoadActor('modhelpers.lua') .. {
    Name= "actor_u",
    File= "modhelpers.lua",
  },
  LoadActor('easing.lua') .. {
    Name= "actor_v",
    File= "easing.lua",
  },
  Def.Quad{
    Name= "actor_w",
    InitCommand= function(self)
		
			checked = false;
		
			---------------------------------------------------------
			---------DOCUMENTATION-----------------------------------
			---------------------------------------------------------
			
			--function perframe( beat, endBeat )
				--return true if the current beat is between 'beat' and 'endBeat'
			
			--function mod_shader(beat,key,which)
				--turn on shader key at specified beat (up to 10 keys available, defined by 'which' = 0-9
				
			--function mod_insert(beat,len,mod,len_or_end,pn)
				--insert mod into beat mods table
			--function mod_insert2(time,len,mod,len_or_end,pn)
				--insert mod into time mods table
			--function mod_ease(beat, len, start_strength, end_strength, mod, len_or_end, ease_type, pn, opt1, opt2)
				--insert mod into ease mods table
				
			--function mod_message(beat,msg,persistent)
				--insert something into the actions table.
				--msg can also be a function. If string, a message gets broadcast at that beat
				--if 'persistent' is true, message will run even if editor starts at a beat past it
				
			--function mod_blacklist(t,n)
				--check if number n occurs in table t
				--useful for doing 'every beat EXCEPT the contents of t'
				
			--function simple_m0d(beat,strength,mult,mod)
			--function simple_m0d2(beat,strength,mult,mod,pn)
			--function simple_m0d3(beat,strength,duration,bpm,mod,pn)
				--activate mods at specific beat but also deactivate them
				
			--function mod_wiggle(beat,num,div,amt,speed,mod,pn,first)
				--alternates a mod back and forth before resetting to 0
				
			--function mod_spring(beat,strength,num,mod,pn)
				--like mod_wiggle, but springier
			
			--function mod_springt(time,strength,dur,mod,pn)
				--time-based per-frame alternating mod that decreases based on how much time is left.
					--think doorstopper
			
			--function mod_springt2(time,strength,dur,mod,pn)
				--time-based per-frame alternating mod
			
			--function mod_spring_adjustable(beat,strength,num,period,mod,pn, first)
				--it's not very good
			
			--function mod_beat(beat,strength,pn)
				--turns on beat for the beat specified, at the desired strength	
			
			--function switcheroo_add(beat,which,speed,len,pn)
				--adds a column swap at the desired beat
			--[[	switcheroos = {normal = {0,0}, ldur = {0,0}, reset = {0,0},
					flip = {100,0}, rudl = {100,0}, invert = {0,100}, dlru = {0,100},
					ludr = {25,-75}, rdul = {75,75}, drlu = {25,125}, ulrd = {75,-125}, urld = {100,-100}}
			]]
			
			--function mod_sugarkiller(beat,duration,speed,minstealth,maxstealth,pn)
				--portable version of the effect from sugarkill X
			
			
			
			
			--function modulo(a, b)
				--returns the remainder when a is divided by b, works properly with negatives unlike math.mod
				
			---------------------------------------------------------
			--------END DOCUMENTATION--------------------------------
			---------------------------------------------------------
			
			
			
			
			
			
			
			
			
			init_modsp1 = '';
			init_modsp2 = '';
			
			mod_plr = {nil, nil};--Even jokes must be safe. -Kid
			
			mod_firstSeenBeat = GAMESTATE:GetSongBeat(); --necessary to prevent long freezes
			
			
---------------------------------------------------------------------------------------
----------------------Begin tables 'n stuff--------------------------------------------
---------------------------------------------------------------------------------------

			--beat based mods
			--{beat_start, beat_end, mods, len_or_end, player_number}
			mods = {
				{0,9999,'*2 2x, *10000 overhead, *10000 no stealth, *10000 no dark, *10000 no reverse, *10000 -10000 cover','end'},
				--These SuddenOffsets are used to help deal with how 5.2 renders notes. -Kid
				--1.85 to 5.12 (beat 1.4 to 6.6)
				{1.4,6.6,'*10000 1000% Sudden, *10000 160% SuddenOffset','end'},
				{6.6,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},
				--7.45 to 8.24 (beat 10.9 to 12.6)
				{10.9,12.6,'*10000 1000% Sudden, *10000 160% SuddenOffset','end'},
				{12.6,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},
				--66.30 to 67.26 (beat 112.4 to 113.8)
				{112.4,113.8,'*10000 1000% Sudden, *10000 160% SuddenOffset','end'},
				{113.8,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},
				--70.30 to 71.30 (beat 119 to 121.8)
				{119,121.8,'*10000 1000% Sudden, *10000 160% SuddenOffset','end'},
				{121.8,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},
				--83.70 to 85 (beat 145.4 to 147.8)
				{145.4,147.8,'*10000 1000% Sudden, *10000 160% SuddenOffset','end'},
				{147.8,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},
			}
			
			--beat-based ease mods
			--{time_start, time_end, mod_start, mod_end, mod, len_or_end, ease_type, player_number, sustaintime, optional_param1, optional_param2}
			--valid ease types are:
				--linear
				--inQuad    outQuad    inOutQuad    outInQuad
				--inCubic   outCubic   inOutCubic   outInCubic
				--inQuart   outQuart   inOutQuart   outInQuart
				--inQuint   outQuint   inOutQuint   outInQuint
				--inSine    outSine    inOutSine    outInSine
				--inExpo    outExpo    inOutExpo    outInExpo
				--inCirc    outCirc    inOutCirc    outInCirc
				--inElastic outElastic inOutElastic outInElastic    --can take 2 optional parameters - amplitude & period
				--inBack    outBack    inOutBack    outInBack       --can take 1 optional parameter  - spring amount
				--inBounce  outBounce  inOutBounce  outInBounce
				
			mods_ease = {--To ensure this works with PlayerOptions, mod names get capitalized properly. -Kid
				{1.5, 0.5, 0, 50, 'Cross', 'len', outCirc, nil, 0.5},
				{1.5, 0.5, 0, 50, 'Split', 'len', outCirc, nil, 0.5},
				{1.5, 0.5, 0, -50, 'Alternate', 'len', outCirc, nil, 0.5},
				{2.5, 0.5, 50, 0, 'Cross', 'len', outCirc, nil, 0.5},
				{2.5, 0.5, 50, 0, 'Split', 'len', outCirc, nil, 0.5},
				{2.5, 0.5, -50, 0, 'Alternate', 'len', outCirc, nil, 0.5},
				{3.5, 0.5, 0, 50, 'Cross', 'len', outCirc},
				{3.5, 0.5, 0, 50, 'Split', 'len', outCirc},
				{3.5, 0.5, 0, -50, 'Alternate', 'len', outCirc},
				{4.0, 0.5, 50, 0, 'Cross', 'len', outCirc},
				{4.0, 0.5, 50, 0, 'Split', 'len', outCirc},
				{4.0, 0.5, -50, 0, 'Alternate', 'len', outCirc},
				{4.5, 0.5, 0, 100, 'Reverse', 'len', outCirc, nil, 7},
				{5.5, 0.5, 0, 50, 'Cross', 'len', outCirc, nil, 0.5},
				{5.5, 0.5, 0, 50, 'Split', 'len', outCirc, nil, 0.5},
				{5.5, 0.5, 0, -50, 'Alternate', 'len', outCirc, nil, 0.5},
				{5.5, 0.25, 0, 100, 'Flip', 'len', outCirc, nil, 0.75},
				{6.5, 0.25, 100, 0, 'Flip', 'len', outCirc},
				{6.0, 0.5, 50, 0, 'Cross', 'len', outCirc},
				{6.0, 0.5, 50, 0, 'Split', 'len', outCirc},
				{6.0, 0.5, -50, 0, 'Alternate', 'len', outCirc},
				{9.5, 0.5, 0, 100, 'Distant', 'len', outCirc},
				{10, 0.5, 100, -100, 'Distant', 'len', outCirc},
				{10.5, 0.5, -100, 0, 'Distant', 'len', outCirc},
				
				{9.5, 0.25, 0, -100, 'Invert', 'len', outCirc, nil, 0.25},
				{10, 0.25, -100, 0, 'Invert', 'len', outCirc, nil, 0.25},
				{10.5, 0.25, 0, -100, 'Invert', 'len', outCirc, nil, 0.25},
				{11, 0.25, -100, 0, 'Invert', 'len', outCirc, nil, 0.25},
				{9.5, 0.25, 0, 100, 'Flip', 'len', outCirc, nil, 0.25},
				{10, 0.25, 100, 0, 'Flip', 'len', outCirc, nil, 0.25},
				{10.5, 0.25, 0, 100, 'Flip', 'len', outCirc, nil, 0.25},
				{11, 0.25, 100, 0, 'Flip', 'len', outCirc, nil, 0.25},
				
				{11.0, 0.5, 100, 66, 'Reverse', 'len', outCirc},
				{11.5, 0.5, 66, 33, 'Reverse', 'len', outCirc},
				{12.0, 0.5, 33, 0, 'Reverse', 'len', outCirc},
				{12.44, 0.5, 200, 200, 'Drunk', 'len', outCirc},
				{12.88, 0.5, -200, -200, 'Drunk', 'len', outCirc},
				{12.88, 0.5, 100, 100, 'Reverse', 'len', outCirc},
				{13.13, 0.5, 200, 0, 'Drunk', 'len', outCirc},
				{12.44, 0.5, 200, 200, 'Tipsy', 'len', outCirc},
				{12.88, 0.5, -200, -200, 'Tipsy', 'len', outCirc},
				{13.13, 0.5, 200, 0, 'Tipsy', 'len', outCirc},
				{13.13, 0.5, 0, 0, 'Reverse', 'len', outCirc},
				
				{14.17, 0.25, 0, 200, 'Mini', 'len', outCirc, nil, 0.75},
				{15, 0.5, 200, 0, 'Mini', 'len', outCirc},
				
				-- hi gh e f f or t
				{16, 0.16, 0, 200, 'Tipsy', 'len', outCirc},
				{16.16, 0.16, -200, 0, 'Tipsy', 'len', outCirc},
				{16.63, 3, -200, 0, 'Drunk', 'len', outCirc},
				{17.06, 3, -100, 0, 'Tornado', 'len', outCirc},
				{17.44, 3, -100, 0, 'Tipsy', 'len', outCirc},
				{17.60, 3, -100, 0, 'Distant', 'len', outCirc},--Scale Bumpy. -Kid
				{18.1, 3, -300*liloss_sdwidth_ratio, 0, 'Bumpy', 'len', outCirc},
				{18.52, 3, -100, 0, 'Tipsy', 'len', outCirc},
				{19.35, 3, -100, 0, 'Drunk', 'len', outCirc},
				{19.58, 3, -100, 0, 'Tornado', 'len', outCirc},
				{20, 3, -100, 0, 'Drunk', 'len', outCirc},
				{20.19, 3, -100, 0, 'Tipsy', 'len', outCirc},
				{20.4, 3, -300*liloss_sdwidth_ratio, 0, 'Bumpy', 'len', outCirc},
				{20.58, 3, -100, 0, 'Hallway', 'len', outCirc},
				{21, 3, -100, 0, 'Distant', 'len', outCirc},
				{21.42, 2, -100, 0, 'Tornado', 'len', outCirc},
				{21.96, 1.5, -100, 0, 'Drunk', 'len', outCirc},
				{22.13, 1.5, -100, 0, 'Tipsy', 'len', outCirc},
				
				{16, 0.16, 100, 100, 'Flip', 'len', outCirc},
				{16.16, 0.16, 0, 0, 'Flip', 'len', outCirc},
				{16.63, 3, 100, 100, 'Invert', 'len', outCirc},
				{17.06, 3, 0, 0, 'Invert', 'len', outCirc},
				{17.44, 3, 100, 100, 'Flip', 'len', outCirc},
				{17.60, 3, 0, 0, 'Flip', 'len', outCirc},
				{18.1, 3, 100, 100, 'Invert', 'len', outCirc},
				{18.52, 3, 0, 0, 'Invert', 'len', outCirc},
				{19.35, 3, 100, 100, 'Flip', 'len', outCirc},
				{19.58, 3, 0, 0, 'Flip', 'len', outCirc},
				{20, 3, 100, 100, 'Invert', 'len', outCirc},
				{20.19, 3, 0, 0, 'Invert', 'len', outCirc},
				{20.4, 3, 100, 100, 'Flip', 'len', outCirc},
				{20.58, 3, 0, 0, 'Flip', 'len', outCirc},
				{21, 3, 100, 100, 'Invert', 'len', outCirc},
				{21.42, 2, 0, 0, 'Invert', 'len', outCirc},
				{21.96, 1.5, 100, 100, 'Flip', 'len', outCirc},
				{22.13, 1.5, 0, 0, 'Flip', 'len', outCirc},
				
				{23, 0.5, 0, 100, 'Dark', 'len', outCirc, nil, 11},
				
				{35, 1, 0, 100, 'Hallway', 'len', outCirc},
				{36, 1, 100, 200, 'Hallway', 'len', outCirc},
				
				{49.75, 0.25, 0, 190, 'Mini', 'len', outCirc, nil, 1},
				{49.75, 0.25, 0, 100, 'Flip', 'len', outCirc, nil, 1},
				{51, 0.25, 190, 0, 'Mini', 'len', outCirc},
				{51, 0.25, 100, 0, 'Flip', 'len', outCirc},
				
				{53, 2, 0, 200, 'Drunk', 'len', outCirc, nil, 5},
				{53, 2, 0, 50, 'Tipsy', 'len', outCirc, nil, 5},
				{60, 1, 200, 0, 'Drunk', 'len', outCirc},
				{60, 1, 50, 0, 'Tipsy', 'len', outCirc},
				
				{64, 0.5, 100, 50, 'Flip', 'len', outCirc, nil, 0.5},
				{63.5, 0.5, 0, -100, 'Mini', 'len', outCirc, nil, 1},
				{65, 2, -100, 0, 'Mini', 'len', outQuad},
				{65, 2, 50, 0, 'Flip', 'len', outQuad},
				
				{65, 2, 0, 200, 'Drunk', 'len', outCirc, 1, 30},
				{65, 2, 0, 50, 'Tipsy', 'len', outCirc, 1, 30},
				{97, 2, 200, 0, 'Drunk', 'len', outCirc, 1},
				{97, 2, 50, 0, 'Tipsy', 'len', outCirc, 1},
				
				{41.46, 0.12, 100, 100, 'Stealth', 'len', outCirc, 2},
				{41.58, 0.38, 100, 100, 'Stealth', 'len', outCirc, 1},
				{41.96, 0.12, 100, 100, 'Stealth', 'len', outCirc, 2},
				{42.08, 0.88, 100, 100, 'Stealth', 'len', outCirc, 1},
				{42.96, 0.12, 100, 100, 'Stealth', 'len', outCirc, 2},
				{43.08, 0.38, 100, 100, 'Stealth', 'len', outCirc, 1},
				{43.46, 0.06, 100, 100, 'Stealth', 'len', outCirc, 2},
				{43.52, 0.33, 100, 100, 'Stealth', 'len', outCirc, 1},
				{43.85, 0.07, 100, 100, 'Stealth', 'len', outCirc, 2},
				{43.92, 0.16, 100, 100, 'Stealth', 'len', outCirc, 1},
				{44.08, 0.13, 100, 100, 'Stealth', 'len', outCirc, 2},
				{44.21, 0.79, 100, 100, 'Stealth', 'len', outCirc, 1},
				{45, 0.5, 100, 100, 'Stealth', 'len', outCirc, 2},
				{45.5, 0.25, 100, 100, 'Stealth', 'len', outCirc, 1},
				{45.75, 0.5, 100, 100, 'Stealth', 'len', outCirc, 2},
				{46.25, 0.25, 100, 100, 'Stealth', 'len', outCirc, 1},
				{46.5, 0.5, 100, 100, 'Stealth', 'len', outCirc, 2},
				{47, 0.25, 100, 100, 'Stealth', 'len', outCirc, 1},
				
				{41.46, 0.12, 100, 100, 'Dark', 'len', outCirc, 2},
				{41.58, 0.38, 100, 100, 'Dark', 'len', outCirc, 1},
				{41.96, 0.12, 100, 100, 'Dark', 'len', outCirc, 2},
				{42.08, 0.88, 100, 100, 'Dark', 'len', outCirc, 1},
				{42.96, 0.12, 100, 100, 'Dark', 'len', outCirc, 2},
				{43.08, 0.38, 100, 100, 'Dark', 'len', outCirc, 1},
				{43.46, 0.06, 100, 100, 'Dark', 'len', outCirc, 2},
				{43.52, 0.33, 100, 100, 'Dark', 'len', outCirc, 1},
				{43.85, 0.07, 100, 100, 'Dark', 'len', outCirc, 2},
				{43.92, 0.16, 100, 100, 'Dark', 'len', outCirc, 1},
				{44.08, 0.13, 100, 100, 'Dark', 'len', outCirc, 2},
				{44.21, 0.79, 100, 100, 'Dark', 'len', outCirc, 1},
				{45, 0.5, 100, 100, 'Dark', 'len', outCirc, 2},
				{45.5, 0.25, 100, 100, 'Dark', 'len', outCirc, 1},
				{45.75, 0.5, 100, 100, 'Dark', 'len', outCirc, 2},
				{46.25, 0.25, 100, 100, 'Dark', 'len', outCirc, 1},
				{46.5, 0.5, 100, 100, 'Dark', 'len', outCirc, 2},
				{47, 0.25, 100, 100, 'Dark', 'len', outCirc, 1},
				
				{49, 0.75, 0, 200, 'Drunk', 'len', outQuad},
				{49, 0.75, 0, -200, 'Tipsy', 'len', outQuad},
				{49, 0.75, 0, 200, 'Tornado', 'len', outQuad},
				{49.75, 0.25, 200, 0, 'Drunk', 'len', outQuad},
				{49.75, 0.25, -200, 0, 'Tipsy', 'len', outQuad},
				{49.75, 0.25, 200, 0, 'Tornado', 'len', outQuad},
				
				{101.5, 0.5, 0, 200, 'Drunk', 'len', outQuad, nil, 0.5},
				{102.5, 0.5, 200, 0, 'Drunk', 'len', outQuad},
				{103, 1, 0, -8000, 'Mini', 'len', inQuad},
				{103, 1, 0, 100, 'Stealth', 'len', inQuad},
				{104, 1, 100, 0, 'Stealth', 'len', outQuad},
				{103, 1, 0, 100, 'Dark', 'len', outExpo},
				{104, 1, 100, 0, 'Dark', 'len', outQuad},
				{104, 1, 0, 0, 'Mini', 'len', outQuad},
				
				{107, 0.5, 0, 100, 'Flip', 'len', outCirc},
				{107.5, 0.5, 100, 100, 'Flip', 'len', outCirc},
				{107.5, 0.5, 0, -100, 'Invert', 'len', outCirc},
				{108, 0.5, -100, 100, 'Invert', 'len', outCirc, nil, 0.5},
				{108, 0.5, 100, 0, 'Flip', 'len', outCirc},
				{109, 0.5, 100, 0, 'Invert', 'len', outCirc},
				
				{110.5, 2, 0, 200, 'Drunk', 'len', outQuad},
				{110.5, 2, 0, -200, 'Tipsy', 'len', outQuad},
				{110.5, 2, 0, 200, 'Tornado', 'len', outQuad},
				{112.5, 0.25, 200, 0, 'Drunk', 'len', outQuad},
				{112.5, 0.25, -200, 0, 'Tipsy', 'len', outQuad},
				{112.5, 0.25, 200, 0, 'Tornado', 'len', outQuad},
				{112.5, 0.25, 0, 50, 'Reverse', 'len', outQuad, nil, 0.75},
				{113.5, 0.25, 50, 0, 'Reverse', 'len', outQuad},
				
				{114.5, 0.5, 120, 120, 'Centered', 'len', outQuad},
				{115, 0.5, 60, 60, 'Centered', 'len', outQuad},
				{115.5, 0.25, 0, 0, 'Centered', 'len', outQuad},
				{115.75, 0.5, 120, 120, 'Centered', 'len', outQuad},
				{116.19, 0.8, 60, 60, 'Centered', 'len', outQuad},
				{117, 0.5, 0, 0, 'Centered', 'len', outQuad},
				{117.5, 0.25, 0, 200, 'Mini', 'len', outCirc, nil, 0.25},
				{118, 0.25, 200, 0, 'Mini', 'len', outCirc},
				{118, 0.42, 120, 120, 'Centered', 'len', outQuad},
				{118.42, 0.6, 60, 60, 'Centered', 'len', outQuad},
				{119, 0.5, 0, 0, 'Centered', 'len', outQuad},
				{119.25, 0.75, 120, 120, 'Centered', 'len', outQuad},
				{120, 0.5, 120, 0, 'Centered', 'len', outCirc},
				{120, 0.5, 0, 100, 'Reverse', 'len', outCirc, nil, 0.75},
				{120.75, 0.5, 60, 60, 'Centered', 'len', outCirc, nil, 0.75},
				{121.25, 0.5, 0, 0, 'Centered', 'len', outCirc, nil, 0.75},
				{121.25, 0.5, 100, 0, 'Reverse', 'len', outCirc},
				{120, 0.5, 0, 300, 'Drunk', 'len', outCirc},
				{120.5, 0.5, 300, 0, 'Drunk', 'len', outCirc},
				{123.25, 0.5, -200, 0, 'Tipsy', 'len', outCirc},
				
				{122.5, 0.5, -75, 0, 'Mini', 'len', outQuad},
				{123, 0.5, -75, 0, 'Mini', 'len', outQuad},
				{123.25, 0.5, 75, 0, 'Mini', 'len', outQuad},
				{123.25, 0.5, 200, 200, 'Distant', 'len', outQuad},
				{123.667, 0.5, 0, 0, 'Distant', 'len', outQuad},
				{123.667, 0.5, -75, 0, 'Mini', 'len', outQuad},
				
				{128.5, 1, 0, 400, 'Drunk', 'len', outQuad},
				{129.5, 1, 400, -400, 'Drunk', 'len', outQuad},
				{128.5, 1, 0, 168, 'Dizzy', 'len', outQuad},
				{129.5, 1, 168, -168, 'Dizzy', 'len', outQuad},
				{130.5, 0.5, -400, 0, 'Drunk', 'len', outCirc},
				{130.5, 0.5, 168, 0, 'Dizzy', 'len', outCirc},
				
				{134, 0.5, 0, 100, 'Flip', 'len', outCirc},
				{134.5, 0.5, 100, 100, 'Flip', 'len', outCirc},
				{134.5, 0.5, 0, -100, 'Invert', 'len', outCirc},
				{135, 0.5, -100, 100, 'Invert', 'len', outCirc, nil, 0.5},
				{135, 0.5, 100, 0, 'Flip', 'len', outCirc},
				{136, 0.5, 100, 0, 'Invert', 'len', outCirc},
				
				{136.25, 0.25, 0, -200, 'Drunk', 'len', outCirc, nil, 5},
				{136.25, 0.25, 0, -50, 'Tipsy', 'len', outCirc, nil, 5},
				{136.5, 2, 200, 200, 'Drunk', 'len', outCirc, nil, 5},
				{136.5, 2, 50, 50, 'Tipsy', 'len', outCirc, nil, 5},
				{143, 2, 200, 0, 'Drunk', 'len', outCirc},
				{143, 2, 50, 0, 'Tipsy', 'len', outCirc},
				{145.5, 0.25, 0, 50, 'Reverse', 'len', outCirc, nil, 1.75},
				{147.5, 0.25, 50, 0, 'Reverse', 'len', outCirc},
			}
			
			for j = 0, 2 do
				for i = 0, 5 do
					local mult = math.mod(j + i, 2)
					mod_ease(23 + 2 * i + 0.5 * j, 0.5, mult * 100, (1 - mult) * 100, 'Invert', 'len', outCirc, nil, 0.5)
					mod_ease(23 + 2 * i + 0.5 * j, 1, (mult * 2 - 1) * 628, 0, 'Dizzy', 'len', linear)
					mod_ease(23 + 2 * i + 0.5 * j, 1, 100, 0, 'Brake', 'len', outQuad)
					mod_ease(23 + 2 * i + 0.5 * j, 0.5, -75, 0, 'Mini', 'len', outQuad)
				end
				
				local mult = math.mod(j, 2)
				mod_ease(61 + 0.5 * j, 0.5, mult * 100, (1 - mult) * 100, 'Flip', 'len', outCirc, nil, 1.5)
				mod_ease(61 + 0.5 * j, 1, (mult * 2 - 1) * 628, 0, 'Dizzy', 'len', linear)
				mod_ease(61 + 0.5 * j, 1, 100, 0, 'Brake', 'len', outQuad)
				mod_ease(61 + 0.5 * j, 0.5, -75, 0, 'Mini', 'len', outQuad)
				
				mod_ease(97 + 0.5 * j, 1, 100, 0, 'Brake', 'len', outQuad)
				mod_ease(97 + 0.5 * j, 0.5, -75, 0, 'Mini', 'len', outQuad)
				mod_ease(144.5 + 0.5 * j, 1, 100, 0, 'Brake', 'len', outQuad)
				mod_ease(144.5 + 0.5 * j, 0.5, -75, 0, 'Mini', 'len', outQuad)
			end
			
			for i = 0, 5 do
				local mult = math.mod(i + 1, 2)
				mod_insert(38 + 0.25 * i, 0.25, '*10000 '.. mult * 100 ..' flip', 'len')
			end
			
			for i = 0, 8 do
				local mult = math.mod(i, 2)
				mod_insert(41.75 + 0.5 * i, 0.5, '*10000 '.. mult * 100 .. ' reverse', 'len', 1)
				mod_insert(41.75 + 0.5 * i, 0.5, '*10000 '.. (1 - mult) * 100 .. ' reverse', 'len', 2)
			end
			
			for i = 0, 4 do
				local mag = i * 70 + 70
				local mag2 = (i + 1) * 70 + 70
				if i == 0 then mag = 0 end
				mod_ease(148 + i, 0.5, mag, -mag2, 'Drunk', 'len', outCirc)
				mod_ease(148.5 + i, 0.5, -mag2, mag2, 'Drunk', 'len', outCirc)
				mod_ease(148 + i, 0.5, mag * 0.5, -mag2 * 0.5, 'Tornado', 'len', outCirc)
				mod_ease(148.5 + i, 0.5, -mag2 * 0.5, mag2 * 0.5, 'Tornado', 'len', outCirc)
			end
			
					
			--time based mods
			mod_time = 0;
			--{time_start, time_end, mods, len_or_end, player_number}
			mods2 = {
			}
			
			--this is both a message broadcaster and a function runner
			--if you put {beat,'String'}, then 'String' is broadcast as a message on that beat
			--if you put {beat,function() somecode end}, then function() is run at that beat
			--see example on beat 0
			
			curaction = 1;
			--{beat,thing,persists}
			mod_actions = {
				{0, function() for pn = 1, 2 do local a = Plr(pn) if a then
						local mult = pn * 2 - 3
						a:AddWrapperState()--For the ending. -Kid
						a:x(SCREEN_CENTER_X + mult * 160*liloss_width_ratio)--Force initial position
						a:decelerate(m_bl * 0.5)
						a:rotationz(-15)
						a:sleep(m_bl * 0.5)
						a:decelerate(m_bl * 0.25)
						a:rotationz(15)
						a:sleep(m_bl * 0.25)
						a:decelerate(m_bl * 0.25)
						a:rotationz(0)
				end end end},
				{7.5, function() for pn = 1, 2 do local a = Plr(pn) if a then
						a:decelerate(m_bl * 0.25)
						a:rotationz(15)
						a:sleep(m_bl * 0.25)
						a:decelerate(m_bl * 0.25)
						a:rotationz(-15)
						a:sleep(m_bl * 0.25)
						a:decelerate(m_bl * 0.25)
						a:rotationz(0)
				end end end},
				
				{64, function() for pn = 1, 2 do local a = Plr(pn) if a then
						a:decelerate(m_bl * 0.25)
						a:x(SCREEN_CENTER_X)
				end end end},
				--Scale movement, and give P2 a sane zoomz. -Kid
				{64.5, function() if P2 then P2:x(SCREEN_CENTER_X - 8000*liloss_height_ratio):zoomz((2/7)*liloss_height_ratio) end end},
				{67, function() if P2 then P2:x(SCREEN_CENTER_X + 1240*liloss_height_ratio) end end},
				{72, function() if P2 then P2:x(SCREEN_CENTER_X - 8000*liloss_height_ratio) end end},
				{73, function() if P2 then P2:x(SCREEN_CENTER_X - 3700*liloss_height_ratio) end end},
				{78, function() if P2 then P2:x(SCREEN_CENTER_X + 3700*liloss_height_ratio) end end},
				{89, function() if P2 then P2:x(SCREEN_CENTER_X - 8000*liloss_height_ratio) end end},
				{91, function() if P2 then P2:x(SCREEN_CENTER_X - 3700*liloss_height_ratio) end end},
				{95, function() if P2 then P2:decelerate(m_bl * 0.25); P2:x(SCREEN_CENTER_X):zoomz(liloss_height_ratio) end end},
				
				{97, function() for pn = 1, 2 do local a = Plr(pn) if a then
						local mult = pn * 2 - 3
						a:decelerate(m_bl * 0.25)--Scale movement. -Kid
						a:x(SCREEN_CENTER_X + mult * 160*liloss_width_ratio / 3)
						a:sleep(m_bl * 0.25)
						a:decelerate(m_bl * 0.25)
						a:x(SCREEN_CENTER_X + mult * 160 * 2*liloss_width_ratio / 3)
						a:sleep(m_bl * 0.25)
						a:decelerate(m_bl * 0.25)
						a:x(SCREEN_CENTER_X + mult * 160*liloss_width_ratio)
				end end end},
				
				{99, function() for pn = 1, 2 do local a = Plr(pn) if a then
						a:decelerate(m_bl * 0.5)
						a:rotationz(-15)
						a:sleep(m_bl * 0.5)
						a:decelerate(m_bl * 0.25)
						a:rotationz(15)
						a:sleep(m_bl * 0.25)
						a:decelerate(m_bl * 0.25)
						a:rotationz(0)
				end end end},
				
				{106, function() for pn = 1, 2 do local a = Plr(pn) if a then
						local mult = pn * 2 - 3
						a:decelerate(m_bl * 0.25)
						a:rotationz(15)
						a:sleep(m_bl * 0.25)
						a:decelerate(m_bl * 0.25)
						a:rotationz(-45)
						a:sleep(m_bl * 3.75)
						a:decelerate(m_bl)
						a:rotationz(0)
				end end end},
				
				{126, function() for pn = 1, 2 do local a = Plr(pn) if a then
						for i = 1, 5 do--Scale zooms. -Kid
							local mult = math.mod(i, 2) * 2 - 1
							a:zoom(liloss_height_ratio + 0.33 * i * liloss_height_ratio)
							a:zoomz(liloss_width_ratio + 100 * i * liloss_width_ratio)
							a:rotationz((20 + 10 * i) * mult)
							a:decelerate(m_bl * 0.5)
							a:zoom(liloss_height_ratio)
							a:zoomz(liloss_height_ratio)
							a:rotationz(0)
							a:sleep(0)
						end
				end end end},
				
				{130.5, function() for pn = 1, 2 do local a = Plr(pn) if a then
						a:decelerate(m_bl * 0.5)
						a:rotationz(-15)
						a:sleep(m_bl * 0.5)
						a:decelerate(m_bl * 0.25)
						a:rotationz(15)
						a:sleep(m_bl * 0.25)
						a:decelerate(m_bl * 0.25)
						a:rotationz(-15)
						a:sleep(m_bl * 0.75)
						a:decelerate(m_bl * 0.25)
						a:rotationz(0)
				end end end},
				
				
				{148, function() for pn = 1, 2 do local a = Plr(pn) if a then
						for i = 1, 5 do--Use wrapper states. -Kid
							a:accelerate(m_bl * 0.5)
							a:rotationx(10 * i)
							a:GetWrapperState(1):accelerate(m_bl * 0.5):zoomz(1 + 2 * i*liloss_sdwidth_ratio)
							a:sleep(m_bl * 0.5)
						end
				end end end},
			}
			
			
			mod_ease(64, 95, -500, -500, 'Flip', 'end', linear, 2)
			mod_ease(95, 0.25, -500, 30, 'Flip', 'len', outQuad, 2, 2)
			mod_insert(64, 95, '*10000 sudden, *10000 dark, *10000 -500 mini, *10000 50 suddenoffset', 'end', 2)
---------------------------------------------------------------------------------------
----------------------Sort the actions table-------------------------------------------
---------------------------------------------------------------------------------------
			
			function modtable_compare(a,b)
				return a[1] < b[1]
			end
			
			if table.getn(mod_actions) > 1 then
				table.sort(mod_actions, modtable_compare)
			end
			
			self:queuecommand('Update');
			
		end,
    OnCommand= cmd(visible,false),
    UpdateCommand= function(self)

			if GAMESTATE:GetSongBeat()>=0 and not checked then
			
				--Added more things to grab/hide. -Kid
				local ThingsToGrab = {'LifeP1','LifeP2','ScoreP1','ScoreP2','BPMDisplay','LifeFrame','ScoreFrame',
				'Lyrics','SongBackground','SongForeground','Overlay','Underlay','StageDisplay',
				'SongTitle','SongMeterDisplayP1','SongMeterDisplayP2','StepsDisplayP1',
				'StepsDisplayP2','LifeMeterBarP1','LifeMeterBarP2'}
				local ThingsToHide = {'LifeP1','LifeP2','ScoreP1','ScoreP2','BPMDisplay','LifeFrame','ScoreFrame',
				'Overlay','Underlay','StageDisplay','SongTitle','SongMeterDisplayP1',
				'SongMeterDisplayP2','StepsDisplayP1','StepsDisplayP2','LifeMeterBarP1',
				'LifeMeterBarP2'}
				
				for i,v in ipairs(ThingsToGrab) do
					_G[v] = SCREENMAN:GetTopScreen():GetChild(v) or nil
				end
				
				for i,v in ipairs(ThingsToHide) do
					if _G[v] then _G[v]:visible(false) end
				end
				
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
				
				--name players, judgment and combo
				for pn=1,2 do
					_G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil;
					if _G['P'..pn] then
						_G['jud'..pn] = _G['P'..pn]:GetChild('Judgment');
						_G['com'..pn] = _G['P'..pn]:GetChild('Combo');
					end
				end
				
				screen = SCREENMAN:GetTopScreen();
				checked = true; --let this only run once
				
			end

			local beat = GAMESTATE:GetSongBeat()
			
---------------------------------------------------------------------------------------
----------------------Begin table handlers---------------------------------------------
---------------------------------------------------------------------------------------
			
			disable = false;
			if disable ~= true and checked and beat > mod_firstSeenBeat+0.1 then
				
				-----------------------
				-- Player mod resets --
				-----------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i=1,2 do
						--GAMESTATE:ApplyGameCommand('mod,clearall',i)
						taronuke_mods('clearall',i)
						if _G['init_modsp'..i] then 
							--GAMESTATE:ApplyGameCommand('mod,'.._G['init_modsp'..i],i)
							taronuke_mods(_G['init_modsp'..i],i)
						end
					end
				end
				------------------------------------------------------------------------------
				-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
				------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if beat >=v[1] then
								if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
									if table.getn(v) == 5 then
										--GAMESTATE:ApplyGameCommand('mod,'..v[3],v[5]);
										taronuke_mods(v[3],v[5])
									else
										--GAMESTATE:ApplyGameCommand('mod,'..v[3]);
										taronuke_mods(v[3],1)
										taronuke_mods(v[3],2)
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = '';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')');
						end
					end
				end
				
				-----------------------------------------------------------------------------------------------------
				-- WinDEU's time-based len/end version of the #swag custom mod reader #teamproofofconcept (c) 2015 --
				-----------------------------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods2) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if mod_time >=v[1] then
								if (v[4] == 'len' and mod_time <=v[1]+v[2]) or (v[4] == 'end' and mod_time <=v[2]) then
									if table.getn(v) == 5 then
										--GAMESTATE:ApplyGameCommand('mod,'..v[3],v[5]);
										taronuke_mods(v[3],v[5])
									else
										--GAMESTATE:ApplyGameCommand('mod,'..v[3]);
										taronuke_mods(v[3],1)
										taronuke_mods(v[3],2)
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = 'error';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in time-based table (line '..i..')');
						end
					end
				end
				
				---------------------------------------------------
				-- ease mod reader v2                            --
				-- friendship ended with if wall                 --
				-- now functions as parameters is my best friend --
				---------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods_ease) do
						if v and table.getn(v) > 6 and v[1] and v[2] and v[3] and v[4] and v[5] and v[6] and v[7] then
							if beat >=v[1] then
								if (v[6] == 'len' and beat <=v[1]+v[2]) or (v[6] == 'end' and beat <=v[2]) then
									
									local duration = v[2];
									if v[6] == 'end' then duration = v[2] - v[1] end
									local curtime = beat - v[1]
									local diff = v[4] - v[3]
									local startstrength = v[3]
									local curve = v[7]
									local mod = v[5]
									
									local strength = curve(curtime, startstrength, diff, duration, v[10], v[11]) --extra parameters for back and elastic eases :eyes:
									
									if v[5] == 'xmod' then
										if table.getn(v) >= 8 then
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..strength..'x',v[8]);
											poptions[v[8]]:XMod(strength,10000)
										else
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..strength..'x');
											poptions[1]:XMod(strength,10000)
											poptions[2]:XMod(strength,10000)
										end
									else
										if table.getn(v) >= 8 and v[8] then--Yes, we have to check for v[8]. -Kid
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..strength..' '..mod,v[8]);
											poptions[v[8]][mod](poptions[v[8]],strength/100,10000)
										else
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..strength..' '..mod);
											poptions[1][mod](poptions[1],strength/100,10000)
											poptions[2][mod](poptions[2],strength/100,10000)
										end
									end
								elseif (v[9] and ((v[6] == 'len' and beat <=v[1]+v[2]+v[9]) or (v[6] == 'end' and beat <=v[9]))) then
									if v[5] == 'xmod' then
										if v[8] then
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..v[4]..'x', v[8]);
											poptions[v[8]]:XMod(v[4],10000)
										else
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..v[4]..'x');
											poptions[1]:XMod(v[4],10000)
											poptions[2]:XMod(v[4],10000)
										end
									else
										if v[8] then
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..v[4]..' '..v[5], v[8]);
											poptions[v[8]][v[5]](poptions[v[8]],v[4]/100,10000)
										else
											--GAMESTATE:ApplyGameCommand('mod,*10000 '..v[4]..' '..v[5]);
											poptions[1][v[5]](poptions[1],v[4]/100,10000)
											poptions[2][v[5]](poptions[2],v[4]/100,10000)
										end
									end
								end
							end
						else
							SCREENMAN:SystemMessage('Bad mod in beat-based ease table (line '..i..')');
						end
					end
				end
				
				--------------------
				-- Perframe stuff --
				--------------------
				
				
				
				---------------------------------------
				-- Actions table --
				---------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
						if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
							if type(mod_actions[curaction][2]) == 'function' then
								mod_actions[curaction][2]()
							elseif type(mod_actions[curaction][2]) == 'string' then
								MESSAGEMAN:Broadcast(mod_actions[curaction][2]);
							end
						end
						curaction = curaction+1;
					end
				end
			end
			self:sleep(0.02);
			self:queuecommand('Update');

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
  },
  Def.BitmapText{
    Name= "actor_x",
    Font= "Common Normal",
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,"music";playcommand,"SetTime";visible,false),
    SetTimeCommand= function(self) self:settext(self:GetSecsIntoEffect()); mod_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
    Text= "test",
  },
}
