--TaroNuke's Mod system. Taken from Puuro's 'Hopes And Dreams' file.
--Since this is intended to work on most SM5 versions, I'll use this. -Kid
LoadActor("mods-taro.lua") --Load another lua file.
return Def.ActorFrame{
  Name= "actor_h",
  InitCommand= function(self)

	songName = GAMESTATE:GetCurrentSong():GetSongDir();
	
	sw = SCREEN_WIDTH
	sh = SCREEN_HEIGHT --shortcuts
	
	function Plr(pn)
		return _G['P'..pn]
	end
	
	function mod_do(str,pn)
		if pn then
			--GAMESTATE:ApplyGameCommand('mod,'..str,pn)
			taronuke_mods(str,pn)
		else
			--GAMESTATE:ApplyGameCommand('mod,'..str)
			taronuke_mods(str,1)
			taronuke_mods(str,2)
		end
	end
	
end,
  Def.Quad{
    Name= "actor_i",
    InitCommand= cmd(visible,false),
    OnCommand= cmd(sleep,1000),
  },
  LoadActor('modhelpers.lua') .. {
    Name= "actor_j",
    File= "modhelpers.lua",
  },
  Def.Quad{
    Name= "actor_k",
    InitCommand= function(self)
		
			checked = false;
		
			---------------------------------------------------------
			---------DOCUMENTATION-----------------------------------
			---------------------------------------------------------
			
			--function perframe( beat, endBeat )
				--return true if the current beat is between 'beat' and 'endBeat'
			
			--function mod_shader(beat,key,which)
				--turn on shader key at specified beat (up to 10 keys available, defined by 'which' = 0-9
				
			--function mod_insert(beat,len,mod,len_or_end,pn)
				--insert mod into beat mods table
			--function mod_insert2(time,len,mod,len_or_end,pn)
				--insert mod into time mods table
				
			--function mod_message(beat,msg,persistent)
				--insert something into the actions table.
				--msg can also be a function. If string, a message gets broadcast at that beat
				--if 'persistent' is true, message will run even if editor starts at a beat past it
				
			--function mod_blacklist(t,n)
				--check if number n occurs in table t
				--useful for doing 'every beat EXCEPT the contents of t'
				
			--function simple_m0d(beat,strength,mult,mod)
			--function simple_m0d2(beat,strength,mult,mod,pn)
			--function simple_m0d3(beat,strength,duration,bpm,mod,pn)
				--activate mods at specific beat but also deactivate them
				
			--function mod_wiggle(beat,num,div,amt,speed,mod,pn,first)
				--alternates a mod back and forth before resetting to 0
				
			--function mod_springt(time,strength,dur,mod,pn)
				--time-based per-frame alternating mod that decreases based on how much time is left.
					--think doorstopper
			
			--function mod_springt2(time,strength,dur,mod,pn)
				--time-based per-frame alternating mod
			
			--function mod_onebeat(beat,strength,pn)
				--turns on beat for the beat specified, at the desired strength	
			
			--function switcheroo_add(beat,which,speed,len,pn)
				--adds a column swap at the desired beat
			--[[	switcheroos = {normal = {0,0}, ldur = {0,0}, reset = {0,0},
					flip = {100,0}, rudl = {100,0}, invert = {0,100}, dlru = {0,100},
					ludr = {25,-75}, rdul = {75,75}, drlu = {25,125}, ulrd = {75,-125}, urld = {100,-100}}
			]]
			
			--use a variable called 'switcheroo_width' to change how much space is between each column
			--e.g. switcheroo_width = 2 for ayakashi
			
			--function mod_sugarkiller(beat,duration,speed,minstealth,maxstealth,pn)
				--portable version of the effect from sugarkill X
				
			--function doSpline(spd, axis, path, col)
				--draws spline 'path' in specified axis, for specific col. Offsets are *10000, but positions use *spd
				
			--function doSplineAll(spd, axis, path)
				--same as above, but for all columns
				--(faster performance than using doSpline 4 times due to more efficient concat)
			
			--function mindf_rotateAndCounter(xDegrees, yDegrees, zDegrees, player)
				--counteract euler rotations after rotating player in multiple axes, using a TON of math.
			
			
			---------------------------------------------------------
			--------END DOCUMENTATION--------------------------------
			---------------------------------------------------------
			
			local m = mod_insert
			local m2 = mod_message
			
			
			local l = 'len'
			local e = 'end'
			
			
			
			
			
			
			
			init_modsp1 = '';
			init_modsp2 = '';
			
			mod_plr = {};
			
			mod_firstSeenBeat = GAMESTATE:GetSongBeat(); --necessary to prevent long freezes
			
			
			
---------------------------------------------------------------------------------------
----------------------Begin tables 'n stuff--------------------------------------------
---------------------------------------------------------------------------------------

			--beat based mods
			--{beat_start, beat_end, mods, len_or_end, player_number}
			mods = {
				{0,9999,'*2 2x','end'},
				{66,73,'*2 sudden, *1000 90 suddenoffset','end'},
				--Makes it look consistent with ITG. -Kid
				{180,449.61,'*10000 1000 Sudden, *10000 160 SuddenOffset','end'},
				{449.61,0.100,'*10000 1000 Sudden, *10000 160 SuddenOffset','len'},
			}
			
			--switcheroos = {{0,0},{100,0},{0,100},{25,-75},{75,75},{25,125},{75,-125},{100,-100}}
			
			
			
			
			
			
			
			--time based mods
			mod_time = 0;
			--{time_start, time_end, mods, len_or_end, player_number}
			mods2 = {
				--{0,200.345,'3x','end',1},
			}
			
			
			
			
			--this is both a message broadcaster and a function runner
			--if you put {beat,'String'}, then 'String' is broadcast as a message on that beat
			--if you put {beat,function() somecode end}, then function() is run at that beat
			--see example on beat 32
			
			curaction = 1;
			--{beat,thing,persists}
			mod_actions = {
			
				{0,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							a:zoomz(0)
							a:addx(-SCREEN_WIDTH/2)
							a:addy(-SCREEN_HEIGHT/2)
						end
					end
					if SongBackground then
						SongBackground:addx(-SCREEN_WIDTH/2)
						SongBackground:addy(-SCREEN_HEIGHT/2)
					end
					if screen then
						screen:addx(SCREEN_WIDTH/2)
						screen:addy(SCREEN_HEIGHT/2)
					end
				end,true},
				
				{453,function()
					for pn=1,2 do
						local a = Plr(pn)
						if a then
							a:zoomz(0)
							a:addx(SCREEN_WIDTH/2)
							a:addy(SCREEN_HEIGHT/2)
						end
					end
					if SongBackground then
						SongBackground:addx(SCREEN_WIDTH/2)
						SongBackground:addy(SCREEN_HEIGHT/2)
					end
					if screen then
						screen:addx(-SCREEN_WIDTH/2)
						screen:addy(-SCREEN_HEIGHT/2)
					end
				end,true}
				
			}
			
			
			
			
			m2(64.5,function()
				dyscontrolled_rev:linear(30/114)
				dyscontrolled_rev:addx(10)
			end)
			m2(65.5,function()
				dyscontrolled_rev:linear(30/114)
				dyscontrolled_rev:addx(10)
			end)
			m2(66.5,function()
				dyscontrolled_rev:linear(30/114)
				dyscontrolled_rev:addx(10)
			end)
			
			
			for i = 71,408,16 do
				local p = i
				m2(i,function()
					dyscontrolled_rev:finishtweening()
					dyscontrolled_rev:linear(120/114)
					dyscontrolled_rev:addx(-30)
					
					--screen:finishtweening()
					--screen:linear(120/114)
					--screen:zoom(0.95*(1-((p-71)/(408-71)))+0.05);
					screenzoom:linear(120/114):x(0.95*(1-((p-71)/(408-71)))+0.05)
					
					if p >= 343 then
						--screen:rotationz(-30*(0+((p-343)/(408-343))));
						screenrot:linear(120/114):x(-30*(0+((p-343)/(408-343))))
					end
					
					if p >= 137 then
						screenv:finishtweening()
						screenv:linear(120/114)
						screenv:x(screenv:GetX()*1.25)
					end
					
				end,true)
			end
			
			
			m2(425,function()
				--screen:linear(24*60/114)
				--screen:zoom(1)
				--screen:rotationz(0)
				screenzoom:linear(24*60/114):x(1)
				screenrot:linear(24*60/114):x(0)
				screenv:linear(24*60/114)
				screenv:x(0)
			end)
			m2(449,function()
				dyscontrolled_rev:decelerate(120/114)
				dyscontrolled_rev:x(0)
			end)
			
---------------------------------------------------------------------------------------
----------------------Sort the actions table-------------------------------------------
---------------------------------------------------------------------------------------
			
			function modtable_compare(a,b)
				return a[1] < b[1]
			end
			
			if table.getn(mod_actions) > 1 then
				table.sort(mod_actions, modtable_compare)
			end
			
			self:queuecommand('Update');
			
		end,
    OnCommand= cmd(visible,false),
    UpdateCommand= function(self)

			if GAMESTATE:GetSongBeat()>=0 and not checked then
			
				--Added more things to grab/hide. -Kid
				local ThingsToGrab = {'LifeP1','LifeP2','ScoreP1','ScoreP2','BPMDisplay','LifeFrame','ScoreFrame',
				'Lyrics','SongBackground','SongForeground','Overlay','Underlay','StageDisplay',
				'SongTitle','SongMeterDisplayP1','SongMeterDisplayP2','StepsDisplayP1',
				'StepsDisplayP2','LifeMeterBarP1','LifeMeterBarP2'}
				local ThingsToHide = {'LifeP1','LifeP2','ScoreP1','ScoreP2','BPMDisplay','LifeFrame','ScoreFrame',
				'Overlay','Underlay','StageDisplay','SongTitle','SongMeterDisplayP1',
				'SongMeterDisplayP2','StepsDisplayP1','StepsDisplayP2','LifeMeterBarP1',
				'LifeMeterBarP2'}
				
				for i,v in ipairs(ThingsToGrab) do
					_G[v] = SCREENMAN:GetTopScreen():GetChild(v) or nil
				end
				
				for i,v in ipairs(ThingsToHide) do
					if _G[v] then _G[v]:visible(false) end
				end
				
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
				table.insert(mod_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
				
				local mod_is_5_2 = false
				--name players, judgment and combo
				for pn=1,2 do
					_G['P'..pn] = SCREENMAN:GetTopScreen():GetChild('PlayerP'..pn) or nil;
					if _G['P'..pn] then
						_G['jud'..pn] = _G['P'..pn]:GetChild('Judgment');
						_G['com'..pn] = _G['P'..pn]:GetChild('Combo');
						--Check to see what SM5 version we're in. -Kid
						if _G['P'..pn]:GetChild('NoteField').set_skin then
							mod_is_5_2 = true
						end
					end
				end--180
			
				if mod_is_5_2 then
					--Because 5.2's notefield acts weirdly when dealing with large amounts of neg reverse. -Kid
					--Besides, if you're using 5.2, you'll likely have drawsize as a mod. -Kid
					mods[3] = {180,449.61,'*10000 450 drawsize,*10000 1000 Sudden, *10000 400 SuddenOffset','end'}
					mods[4] = {449.61,9999,'*10000 1000 sudden, *10000 160 SuddenOffset,*10000 0 drawsize','end'}
				end
				
				screen = SCREENMAN:GetTopScreen();
				checked = true; --let this only run once
				
			end

			local beat = GAMESTATE:GetSongBeat()
			
			
---------------------------------------------------------------------------------------
----------------------Begin table handlers---------------------------------------------
---------------------------------------------------------------------------------------
			
			disable = false;
			if disable ~= true and beat > mod_firstSeenBeat+0.1 and checked then
				
				-----------------------
				-- Player mod resets --
				-----------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i=1,2 do
						mod_do('clearall',i)
					end
				end
				
				------------------------------------------------------------------------------
				-- custom mod reader by TaroNuke edited by WinDEU and re-stolen by TaroNuke --
				------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if beat >=v[1] then
								if (v[4] == 'len' and beat <=v[1]+v[2]) or (v[4] == 'end' and beat <=v[2]) then
									if table.getn(v) == 5 then
										mod_do(v[3],v[5]);
									else
										mod_do(v[3]);
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = '';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in beat-based table (line '..i..')');
						end
					end
				end
				
				-----------------------------------------------------------------------------------------------------
				-- WinDEU's time-based len/end version of the #swag custom mod reader #teamproofofconcept (c) 2015 --
				-----------------------------------------------------------------------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					for i,v in pairs(mods2) do
						if v and table.getn(v) > 3 and v[1] and v[2] and v[3] and v[4] then
							if mod_time >=v[1] then
								if (v[4] == 'len' and mod_time <=v[1]+v[2]) or (v[4] == 'end' and mod_time <=v[2]) then
									if table.getn(v) == 5 then
										mod_do(v[3],v[5]);
									else
										mod_do(v[3]);
									end
								end
							end
						else
							v[1] = 0;
							v[2] = 0;
							v[3] = 'error';
							v[4] = 'error';
							SCREENMAN:SystemMessage('Bad mod in time-based table (line '..i..')');
						end
					end
				end
				
				--------------------
				-- Perframe stuff --
				--------------------
				
				
				mod_do('*10000 '..dyscontrolled_rev:GetX()..' reverse');
				screen:zoom(screenzoom:GetX()):rotationz(screenrot:GetX())
				
				if beat>137 then
					screen:vibrate()
					screen:effectmagnitude(screenv:GetX(),screenv:GetX(),screenv:GetX())
				end
				
				
				---------------------------------------
				-- ACTION RPGS AINT GOT SHIT ON THIS --
				---------------------------------------
				if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
					while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
						if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
							if type(mod_actions[curaction][2]) == 'function' then
								mod_actions[curaction][2]()
							elseif type(mod_actions[curaction][2]) == 'string' then
								MESSAGEMAN:Broadcast(mod_actions[curaction][2]);
							end
						end
						curaction = curaction+1;
					end
				end
				
			end
			
			self:sleep(0.02);
			self:queuecommand('Update');

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
  },
  Def.BitmapText{
    Name= "actor_l",
    Font= "Common Normal",
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,"music";playcommand,"SetTime";visible,false),
    SetTimeCommand= function(self) self:settext(self:GetSecsIntoEffect()); mod_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
    Text= "test",
  },
  --Unconverted positioning of control quads. -Kid
  Def.Quad{
    Name= "actor_m",
    InitCommand= function(self) dyscontrolled_rev=self end,
    OnCommand= cmd(visible,false;x,0),
  },
  Def.Quad{
    Name= "actor_n",
    InitCommand= function(self) screenv=self end,
    OnCommand= cmd(visible,false;x,1),
  },
  Def.Quad{
    Name= "actor_n",--Because SM5 is strange with how zoom works in conjunction with tweens. -Kid
    InitCommand= function(self) screenzoom=self end,
    OnCommand= cmd(visible,false;x,1),
  },
  Def.Quad{
    Name= "actor_n",--Because we're manipulating zoom, we manipulate rotz as well. -Kid
    InitCommand= function(self) screenrot=self end,
    OnCommand= cmd(visible,false;x,0),
  },
}
