--TaroNuke's Mod system. Taken from Puuro's 'Hopes And Dreams' file.
--Since this is intended to work on most SM5 versions, I'll use this. -Kid
LoadActor("mods-taro.lua") --Load another lua file.
local songName = GAMESTATE:GetCurrentSong():GetSongDir()
return Def.ActorFrame{
  Name= "actor_n",
  Def.Quad{
    Name= "actor_o",
    InitCommand= function(self)
		
		function mod_do(str,pn)
			--GAMESTATE:ApplyGameCommand('mod,'..str)
			taronuke_mods(str,1)
			taronuke_mods(str,2)
		end
		
		function mod_table_shuffle(t) --shuffles a table
			local n = table.getn(t)
			while n >= 2 do
				-- n is now the last pertinent index
				local k = math.random(n) -- 1 <= k <= n
				-- Quick swap
				t[n], t[k] = t[k], t[n]
				n = n - 1
			end
			return t
		end
		
		function modtable_compare(a,b)
			return a[1] < b[1]
		end
		
		function perframe( beat, endBeat )
			local cur = GAMESTATE:GetSongBeat();
			return cur >= mod_firstSeenBeat+1 and cur >= beat and cur < (endBeat or beat+1);
		end
		
		function mod_insert(beat,len,mod,t,pn)
			if not t then t = 'len' end
			table.insert(mods,{beat,len,mod,t,pn});
		end
		
		function mod2_insert(beat,len,mod,t,pn)
			if not t then t = 'len' end
			table.insert(mods2,{beat,len,mod,t,pn});
		end
		
		function mod_ease(beat,len,str1,str2,mod,t,ease,pn,sus,a,p)
			table.insert(mods_ease,{beat,len,str1,str2,mod,t,ease,pn,sus,a,p})
		end
		
		function mod_message(beat,msg,p)
			table.insert(mod_actions,{beat,msg,p});
		end

		function ease_wiggle(beatS,beatE,amt,inc,str,ease,pn)
			local zoomtypes = {'', 'x', 'y', 'z'}
			local rotStart = 0
			local prevRot = amt
			local curRot = -amt
			for k,v in pairs(zoomtypes) do
				if str == 'zoom' .. v then curRot = math.max(-amt,0) end
			end
			for i = beatS,beatE,inc do
				if i == beatS then
					rotStart = 0
				else
					rotStart = prevRot
				end
				if i == beatE then
					rotEnd = 0
				else
					rotEnd = curRot
				end
					mod_ease(i, inc, rotStart, rotEnd, str, 'len', ease, pn)
					prevRot = prevRot *-1
					curRot = curRot *-1
			end
		end

		function ease_wiggleAbs(beatS,beatE,amt,inc,str,ease,pn)
			local rotStart = 0
			local prevRot = 0
			local curRot = amt
			local counter = 1
			for i = beatS,beatE,inc do
				if counter == -1 then
					preRot,curRot = amt, 0
				elseif counter == 1 then
					preRot,curRot = 0, amt
				end
				mod_ease(i-inc, inc, preRot, curRot, str, 'len', ease, pn)
				counter = counter*-1
			end
		end
	
	-- hey alright
	function modulo(a, b)
		return a - math.floor(a/b)*b;
	end

	function Sound(soundName) SOUND:PlayOnce(songName..'fg/'..soundName..'.ogg') end
	function Plr(pn) return _G['P'..pn] end
	--function spb() return 60 / 148 end
	function SysMes(str) SCREENMAN:SystemMessage(tostring(str)) end

	end,
    OnCommand= cmd(visible,false),
  },
}
