local poptions = {GAMESTATE:GetPlayerState(0):GetPlayerOptions('ModsLevel_Song'),GAMESTATE:GetPlayerState(1):GetPlayerOptions('ModsLevel_Song')}
return Def.ActorFrame{
  Name= "actor_r",
  InitCommand= function(self)
	function mod_ease_reader(beat)
		if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
			for i,v in pairs(mods_ease) do
				if v and table.getn(v) > 6 and v[1] and v[2] and v[3] and v[4] and v[5] and v[6] and v[7] then
					if beat >=v[1] then
						if (v[6] == 'len' and beat <=v[1]+v[2]) or (v[6] == 'end' and beat <=v[2]) then
							
							local duration = v[2];
							if v[6] == 'end' then duration = v[2] - v[1] end
							local curtime = beat - v[1]
							local diff = v[4] - v[3]
							local startstrength = v[3]
							local curve = v[7]
							local mod = v[5]
							
							local strength = curve(curtime, startstrength, diff, duration, v[10], v[11]) --extra parameters for back and elastic eases :eyes:
							
							-- 'confusionoffset+' will make the arrows flip back around if their backs are to the screen 
							if string.find(mod, '^confusion') and string.find(mod, '\+$') and modulo(strength, 628) > 157 and modulo(strength, 628) < 471 then
								strength = math.mod(strength, 628) - 314;
								mod = string.sub(mod, 1, -2)
							end
							
							if v[5] == 'xmod' then--Because I can. -Kid
								if table.getn(v) >= 8 then
									--GAMESTATE:ApplyGameCommand('mod,*999 '..strength..'x',v[8]);
									poptions[v[8]]:XMod(strength,999)
								else
									--GAMESTATE:ApplyGameCommand('mod,*999 '..strength..'x');
									poptions[1]:XMod(strength,999)
									poptions[2]:XMod(strength,999)
								end
							else
								if table.getn(v) >= 8 then
									--GAMESTATE:ApplyGameCommand('mod,*999 '..strength..' '..mod,v[8]);
									poptions[v[8]][mod](poptions[v[8]],strength/100,999)
								else
									--GAMESTATE:ApplyGameCommand('mod,*999 '..strength..' '..mod);
									poptions[1][mod](poptions[1],strength/100,999)
									poptions[2][mod](poptions[2],strength/100,999)
								end
							end
						elseif (v[9] and ((v[6] == 'len' and beat <=v[1]+v[2]+v[9]) or (v[6] == 'end' and beat <=v[9]))) then
							if v[5] == 'xmod' then
								if  v[8] then
									--GAMESTATE:ApplyGameCommand('mod,*999 '..v[4]..'x', v[8]);
									poptions[v[8]]:XMod(v[4],999)
								else
									--GAMESTATE:ApplyGameCommand('mod,*999 '..v[4]..'x');
									poptions[1]:XMod(v[4],999)
									poptions[2]:XMod(v[4],999)
								end
							else
								if  v[8] then
									--GAMESTATE:ApplyGameCommand('mod,*999 '..v[4]..' '..v[5], v[8]);
									poptions[v[8]][v[5]](poptions[v[8]],v[4]/100,999)
								else
									--GAMESTATE:ApplyGameCommand('mod,*999 '..v[4]..' '..v[5]);
									poptions[1][v[5]](poptions[1],v[4]/100,999)
									poptions[2][v[5]](poptions[2],v[4]/100,999)
								end
							end
						end
					end
				else
					SCREENMAN:SystemMessage('Bad mod in beat-based ease table (line '..i..')');
				end
			end
		end
	end
end,
}
