--TaroNuke's Mod system. Taken from Puuro's 'Hopes And Dreams' file.
--Since this is intended to work on most SM5 versions, I'll use this. -Kid
LoadActor("mods-taro.lua") --Load another lua file.
local toumeinaloss_height_ratio = SCREEN_HEIGHT/480
--This helps us keep things just a little bit sane. -Kid
local toumeinaloss_width_ratio = math.max(SCREEN_HEIGHT/480,SCREEN_WIDTH/640)
return Def.ActorFrame{
  Name= "actor_vb",
  Def.Quad{
    Name= "actor_wb",
    InitCommand= cmd(visible,false),
    OnCommand= cmd(sleep,1000),
  },
  LoadActor('notedata.lua') .. {
    Name= "actor_xb",
    File= "notedata.lua",
  },
  Def.Quad{
    Name= "actor_yb",
    InitCommand= cmd(visible,false),
    OnCommand= function(self)
				fgcurcommand = 1;
				checked = false;
				prefix_time = 0;
				
				prefix_curmessage = 1;
				
				
				prefix_messages = {
				
				};
				
				
				prefix_mods = {
				
				}
				
				
				prefix_plr = {nil, nil};--Even if it's joke, I won't allow errors. -Kid
				
				for i=1, table.getn(notedata) do
					local a1 = notedata[i][1];
					table.insert(prefix_messages,{a1,'Asdf'});
				end
				
				self:queuecommand('Update');
			end,
    Update2Command= function(self)
		self:sleep(0.02);
		self:queuecommand('Update');
		end,
    UpdateCommand= function(self)
		
			local beat = GAMESTATE:GetSongBeat();
			
			-----------------------
			-- Player mod resets --
			-----------------------
			--GAMESTATE:ApplyGameCommand('mod,clearall')
			taronuke_mods("clearall",1)
			taronuke_mods("clearall",2)
			
			--------------------------------------------------------------------------------------------
			-- Mod reader code originally coded by Taronuke, remade to support end times and lengths. --
			--------------------------------------------------------------------------------------------
			for i,v in pairs(prefix_mods) do
				if prefix_time >=v[1] then
					if (v[4] == 'len' and prefix_time <=v[1]+v[2]) or (v[4] == 'end' and prefix_time <=v[2]) then
						if table.getn(v) == 5 then
							GAMESTATE:ApplyGameCommand('mod,'..v[3],v[5]);
						else
							GAMESTATE:ApplyGameCommand('mod,'..v[3]);
						end
					end
				end
			end
			
			
			
			if beat >= 0 and not checked then
				
				prefix_plr[1] = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
				prefix_plr[2] = SCREENMAN:GetTopScreen():GetChild('PlayerP2');
				checked = true;
				
				--SCREENMAN:GetTopScreen():GetChild('Overlay'):visible(false);
				--SCREENMAN:GetTopScreen():GetChild('Underlay'):visible(false);
				for i,v in pairs(prefix_plr) do
					if v then
						--SCREENMAN:GetTopScreen():GetChild('ScoreP'..i):visible(false);
						--SCREENMAN:GetTopScreen():GetChild('LifeP'..i):visible(false);
						
						
					end
				end
			end
			
			-------------------------
			-- BEAT SPECIFIC STUFF --
			-------------------------
			if beat > 64 and beat < 96 then
				for i,v in pairs(prefix_plr) do
					if v then
						--v:x(SCREEN_CENTER_X+(math.sin(beat*math.pi/2)*auxvar:getaux()))
					end
				end
			end
			
			--------------------------------------------------------------
			-- Message reader to make specific values of the actor aux. --
			--------------------------------------------------------------
			if prefix_curmessage <= table.getn(prefix_messages) then
				if beat >= prefix_messages[prefix_curmessage][1] then
					MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
					prefix_curmessage = prefix_curmessage + 1;
				end
			end
			
			self:queuecommand('Update2');
			
		end,
  },
  Def.BitmapText{
    Name= "actor_zb",
    Font= "Common Normal",
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,"music";playcommand,"SetTime";visible,false),
    SetTimeCommand= function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
    Text= "test",
  },
  Def.Quad{
    Name= "actor_Ab",
    AsdfMessageCommand= function()
			for i,v in pairs(prefix_plr) do
				local randomrotx1 = math.random(-60,60);
				local randomroty1 = math.random(-60,60);
				local randomrotz1 = math.random(-60,60);
				local randomrotx2 = math.random(-60,60);
				local randomroty2 = math.random(-60,60);
				local randomrotz2 = math.random(-60,60);--Scale positioning and zoom. -Kid
				local randomx1 = math.random(128*toumeinaloss_width_ratio,SCREEN_WIDTH-128*toumeinaloss_width_ratio);
				local randomy1 = math.random(128*toumeinaloss_width_ratio,SCREEN_HEIGHT-128*toumeinaloss_width_ratio);
				local randomx2 = math.random(128*toumeinaloss_width_ratio,SCREEN_WIDTH-128*toumeinaloss_width_ratio);
				local randomy2 = math.random(128*toumeinaloss_width_ratio,SCREEN_HEIGHT-128*toumeinaloss_width_ratio);
				local randomzoomx1 = math.random(1,4);
				local randomzoomy1 = math.random(1,4);
				local randomzoomx2 = math.random(1,4);
				local randomzoomy2 = math.random(1,4);
				if v then
					if i == 1 then
						v:x(randomx1);
						v:y(randomy1);
						v:rotationx(randomrotx1);
						v:rotationy(randomroty1);
						v:rotationz(randomrotz1);
						v:zoomx((randomzoomx1*toumeinaloss_height_ratio)/2);
						v:zoomy((randomzoomy1*toumeinaloss_height_ratio)/2);
					else
						v:x(randomx2);
						v:y(randomy2);
						v:rotationx(randomrotx2);
						v:rotationy(randomroty2);
						v:rotationz(randomrotz2);
						v:zoomx((randomzoomx2*toumeinaloss_height_ratio)/2);
						v:zoomy((randomzoomy2*toumeinaloss_height_ratio)/2);
					end
				end
			end
		end,
    InitCommand= function(self) auxvar = self; self:visible(false) end,
    OnCommand= cmd(),
  },
}
